<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Chat/Scripts/5_mission/dayzexpansion_chat/missiongameplay.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.17</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('de/d96/a09070_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">missiongameplay.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../de/d96/a09070.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * MissionGameplay.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment"></span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">/**@class       MissionGameplay</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment"> * @brief       </span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="comment"> **/</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>modded <span class="keyword">class </span><a class="code hl_class" href="../../d5/d3b/a03990.html">MissionGameplay</a></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>{   </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">   18</a></span>    <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a> <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a970414f2d57648e4b93e7ac11f2cdca5">   19</a></span>    Widget <a class="code hl_variable" href="../../d5/d3b/a03990.html#a970414f2d57648e4b93e7ac11f2cdca5">m_ChatPanel</a>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">   20</a></span>    Widget <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">   21</a></span>    TextWidget <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>    </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#afe0a9f610fca7dc48005c29283028b98">   23</a></span>    ref Timer <a class="code hl_variable" href="../../d5/d3b/a03990.html#afe0a9f610fca7dc48005c29283028b98">m_ExChatChannelHideTimer</a>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a5957a5e85046a480f944aa1c63504774">   25</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a5957a5e85046a480f944aa1c63504774">MissionGameplay</a>()</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    {</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#afe0a9f610fca7dc48005c29283028b98">m_ExChatChannelHideTimer</a> = <span class="keyword">new</span> Timer;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>        <a class="code hl_class" href="../../d1/d07/a03482.html">ExpansionSettings</a>.<a class="code hl_variable" href="../../d1/d07/a03482.html#a269a0005757f7ab791bcaac0e46e46e2">SI_Chat</a>.Insert(<a class="code hl_function" href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">Expansion_OnChatSettingsReceived</a>);</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    }</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#acf8a8220e80d16442e972c06f4004635">   32</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#acf8a8220e80d16442e972c06f4004635">~MissionGameplay</a>()</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    {</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <a class="code hl_class" href="../../d1/d07/a03482.html">ExpansionSettings</a>.<a class="code hl_variable" href="../../d1/d07/a03482.html#a269a0005757f7ab791bcaac0e46e46e2">SI_Chat</a>.Remove(<a class="code hl_function" href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">Expansion_OnChatSettingsReceived</a>);</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    }</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a624b850617bf1855ccc4aa43410760a2">   37</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a624b850617bf1855ccc4aa43410760a2">OnInit</a>()</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    {</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        super.OnInit();</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>        </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#a98610ae06d9dc5a684ad7dd7bf7f0e2a">InitExpansionChat</a>();</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a98610ae06d9dc5a684ad7dd7bf7f0e2a">   44</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a98610ae06d9dc5a684ad7dd7bf7f0e2a">InitExpansionChat</a>()</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#a970414f2d57648e4b93e7ac11f2cdca5">m_ChatPanel</a> = Widget.Cast(m_HudRootWidget.FindAnyWidget(<span class="stringliteral">&quot;ChatFrameWidget&quot;</span>));</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d2/d94/a00716.html#ae38cfc715c5007d38ba931e2ed1233f9">m_Chat</a> &amp;&amp; <a class="code hl_variable" href="../../d5/d3b/a03990.html#a970414f2d57648e4b93e7ac11f2cdca5">m_ChatPanel</a>)</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        {</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a> = GetGame().GetWorkspace().CreateWidgets(<span class="stringliteral">&quot;DayZExpansion/Chat/GUI/layouts/expansion_chat_channel.layout&quot;</span>);</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a> = TextWidget.Cast(<a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>.FindAnyWidget(<span class="stringliteral">&quot;ChatChannelName&quot;</span>));</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="comment"></span> </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span><span class="comment">            //! Set default to direct</span></div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span><span class="comment"></span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>();</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        }</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    }</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">   59</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">Expansion_OnChatSettingsReceived</a>()</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    {</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        <a class="code hl_class" href="../../d1/d07/a03482.html">ExpansionSettings</a>.<a class="code hl_variable" href="../../d1/d07/a03482.html#a269a0005757f7ab791bcaac0e46e46e2">SI_Chat</a>.Remove(<a class="code hl_function" href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">Expansion_OnChatSettingsReceived</a>);</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>        <a class="code hl_enumeration" href="../../d0/d7e/a00770.html#a94995a0febe96411aa47647d9f9e8ea4">ExpansionClientUIChatChannel</a> chatChannel = <a class="code hl_function" href="../../dd/d5c/a00752.html#ac819a3ce2982b743e915becd7db4fb9d">GetExpansionClientSettings</a>().<a class="code hl_variable" href="../../d3/d8c/a04318.html#a177040c829eb22a3df76b96af4aa64f9">DefaultChatChannel</a>;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="keywordflow">switch</span> (chatChannel)</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        {</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>            <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../d0/d7e/a00770.html#a94995a0febe96411aa47647d9f9e8ea4">ExpansionClientUIChatChannel</a>.GLOBAL:</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>                <a class="code hl_function" href="../../d5/d3b/a03990.html#a04c04571e97be01a5aaf3a95293023bd">SwitchChatChannelToGlobal</a>();</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>    }</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a82d9062eb09f8de43262773a4ef64caa">   72</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a82d9062eb09f8de43262773a4ef64caa">ShowChat</a>()</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    {</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="comment"></span> </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span><span class="comment">        //! Disable certain controlls and inputs when the chat input menu gets opened.</span></div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span><span class="comment"></span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#acbcf0c64743116229dae1da155069a82">PlayerControlDisable</a>(INPUT_EXCLUDE_ALL);</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#acbcf0c64743116229dae1da155069a82">PlayerControlDisable</a>(<a class="code hl_variable" href="../../da/d28/a09115.html#acca8fa992257e3d4d1cb0f442fb66022">INPUT_EXCLUDE_CHAT_EXPANSION</a>);</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        GetUApi().GetInputByName(<span class="stringliteral">&quot;UAPersonView&quot;</span>).Supress();</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        GetUApi().GetInputByName(<span class="stringliteral">&quot;UAPersonView&quot;</span>).ForceDisable(<span class="keyword">true</span>);</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        GetGame().GetUIManager().ShowUICursor(<span class="keyword">true</span>);</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        <span class="comment"></span></div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span><span class="comment">        //! Not sure why this is here?!</span></div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span><span class="comment"></span>        <span class="keywordflow">if</span> (g_Game.GetProfileOption(EDayZProfilesOptions.PLAYER_MESSAGES))</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span><span class="comment"></span> </div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span><span class="comment">        //! If we are no longer in a vehicle and last used channel was transport, switch to direct</span></div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span><span class="comment"></span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> == <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCTransport)</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        {</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>            <a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a> player = <a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a>.Cast(g_Game.GetPlayer());</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>            Object parent = Object.Cast(player.GetParent());</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span> </div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>            <span class="keywordflow">if</span> (!parent || !parent.IsTransport() || !<a class="code hl_function" href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>().<a class="code hl_variable" href="../../d4/d6a/a00704.html#a9ac85a6fe03a5ee2a389557e2c38fbd4">EnableTransportChat</a>)</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>                <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>();</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        }</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#aee84cfd70f2fdf1e6b161cde0b0c8877">UpdateChannelColor</a>();</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                <span class="comment"></span></div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span><span class="comment">        //! Fade-in chat channel name widgets</span></div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span><span class="comment"></span>        <span class="comment">//FadeInChatChannel();</span></div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        <span class="comment"></span></div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span><span class="comment">        //! Update mic voice level indicator widgets</span></div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span><span class="comment"></span>        <span class="keywordtype">int</span> level = GetGame().GetVoiceLevel();</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>        UpdateVoiceLevelWidgets(level);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        <span class="comment"></span></div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span><span class="comment">        //! Open chat input menu</span></div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span><span class="comment"></span>        m_UIManager.EnterScriptedMenu(MENU_CHAT_INPUT, NULL);</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="comment"></span></div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span><span class="comment">        //! Show chat channel widgets</span></div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span><span class="comment"></span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>.Show(<span class="keyword">true</span>);</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>    }</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    </div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a8cd37e08feb9c0cb32d542a34f8da2e6">  113</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a8cd37e08feb9c0cb32d542a34f8da2e6">HideChat</a>()</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>    {</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        super.HideChat();</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span><span class="comment"></span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span><span class="comment">        //! Enable inputs</span></div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span><span class="comment"></span>        GetUApi().GetInputByName(<span class="stringliteral">&quot;UAPersonView&quot;</span>).ForceDisable(<span class="keyword">false</span>);</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        </div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>.Show(<span class="keyword">false</span>);</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>    }</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a04c04571e97be01a5aaf3a95293023bd">  125</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a04c04571e97be01a5aaf3a95293023bd">SwitchChatChannelToGlobal</a>()</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>().<a class="code hl_variable" href="../../d4/d6a/a00704.html#aacf768f5738a580c7aa1604dcca74b9f">EnableGlobalChat</a>)</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        {</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> = <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCGlobal;</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetText(<span class="stringliteral">&quot;Global Chat&quot;</span>);</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        }</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        {</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a1b46009109a2e05a507ed2009c245f3d">SwitchChatChannelToTeam</a>();</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        }</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>    }</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span> </div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a1b46009109a2e05a507ed2009c245f3d">  140</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a1b46009109a2e05a507ed2009c245f3d">SwitchChatChannelToTeam</a>()</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>    {</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span><span class="preprocessor">#ifdef EXPANSIONMODGROUPS</span></div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <a class="code hl_class" href="../../da/d4d/a05322.html">ExpansionPartyModule</a> partyModule = <a class="code hl_class" href="../../da/d4d/a05322.html">ExpansionPartyModule</a>.Cast(CF_ModuleCoreManager.Get(<a class="code hl_class" href="../../da/d4d/a05322.html">ExpansionPartyModule</a>));</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        <span class="keywordflow">if</span> (partyModule.<a class="code hl_function" href="../../da/d4d/a05322.html#a95efaaf7798d3ceb3a74fd2aebf3235d">HasParty</a>() &amp;&amp; <a class="code hl_function" href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>().EnablePartyChat)</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        {</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> = <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCTeam;</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetText(<span class="stringliteral">&quot;Team Chat&quot;</span>);</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>        }</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        {</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">SwitchChatChannelToTransport</a>();</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        }</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">SwitchChatChannelToTransport</a>();</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    }</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">  161</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">SwitchChatChannelToTransport</a>()</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    {</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span> </div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        <a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a> player = <a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a>.Cast(g_Game.GetPlayer());</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordflow">if</span> (!player || !player.GetParent())</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>        {</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">SwitchChatChannelToAdmin</a>();</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        }</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        </div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        Object parent = Object.Cast(player.GetParent());</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        <span class="keywordflow">if</span> (parent &amp;&amp; parent.IsTransport() &amp;&amp; <a class="code hl_function" href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>().<a class="code hl_variable" href="../../d4/d6a/a00704.html#a9ac85a6fe03a5ee2a389557e2c38fbd4">EnableTransportChat</a>)</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        {</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> = <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCTransport;</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetText(<span class="stringliteral">&quot;Transport Chat&quot;</span>);</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>        {</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">SwitchChatChannelToAdmin</a>();</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>        }</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>    }</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span> </div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">  184</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">SwitchChatChannelToAdmin</a>()</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>    {</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span> </div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d0/d2b/a01010.html#a6a9dab57310f04a6f70fe20ef2e4eed3">GetPermissionsManager</a>().HasPermission(<span class="stringliteral">&quot;Admin.Chat&quot;</span>))</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        {</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> = <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCAdmin;</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>            <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetText(<span class="stringliteral">&quot;Admin Chat&quot;</span>);</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>        }</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>        {</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>();</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        }</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>    }</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">  199</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>()</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    {</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span> </div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a> = <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCDirect;</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetText(<span class="stringliteral">&quot;Direct Chat&quot;</span>);</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>    }</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span> </div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a33850cfa9b721d7b55df4b85186d6b2e">  207</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a33850cfa9b721d7b55df4b85186d6b2e">SwitchChannel</a>()</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>    {</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d7/dc9/a04370.html">EXTrace</a>.<a class="code hl_function" href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.CHAT);</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span> </div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>        m_ChatChannelHideTimer.Stop();</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>.Show(<span class="keyword">true</span>);</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        <span class="keywordflow">switch</span> (<a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a>)</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        {</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCDirect:</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a04c04571e97be01a5aaf3a95293023bd">SwitchChatChannelToGlobal</a>();</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCGlobal:</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a1b46009109a2e05a507ed2009c245f3d">SwitchChatChannelToTeam</a>();</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCTeam:</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">SwitchChatChannelToTransport</a>();</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCTransport:</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">SwitchChatChannelToAdmin</a>();</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>.CCAdmin:</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>();</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        <span class="keywordflow">default</span>:</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>            <a class="code hl_function" href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">SwitchChatChannelToDirect</a>();</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>        }</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>        </div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        <a class="code hl_function" href="../../d5/d3b/a03990.html#aee84cfd70f2fdf1e6b161cde0b0c8877">UpdateChannelColor</a>();</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span> </div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        m_ChatChannelHideTimer.Run(2, <a class="code hl_variable" href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">m_ChatChannelRootWidget</a>, <span class="stringliteral">&quot;Show&quot;</span>, <span class="keyword">new</span> Param1&lt;bool&gt;(<span class="keyword">false</span>));</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>    }</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#aee84cfd70f2fdf1e6b161cde0b0c8877">  241</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#aee84cfd70f2fdf1e6b161cde0b0c8877">UpdateChannelColor</a>()</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    {<span class="comment"></span></div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span><span class="comment">        //! Initialize chat channel name to correct color</span></div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span><span class="comment"></span>        <span class="keywordtype">string</span> chatChannelName = <span class="keyword">typename</span>.EnumToString(<a class="code hl_enumeration" href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a>, <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a>);</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>        <span class="keywordflow">if</span> (chatChannelName == <span class="stringliteral">&quot;CCTeam&quot;</span>)</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>            chatChannelName = <span class="stringliteral">&quot;Party&quot;</span>;</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>            chatChannelName = chatChannelName.Substring(2, chatChannelName.Length() - 2);</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        <a class="code hl_variable" href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">m_ChatChannelName</a>.SetColor(<a class="code hl_function" href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>().ChatColors.Get(chatChannelName + <span class="stringliteral">&quot;ChatColor&quot;</span>));</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>    }</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span> </div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a9b5a2ee56dfa244ecc61ecd37406f91a">  252</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#a9b5a2ee56dfa244ecc61ecd37406f91a">GetChatChannel</a>()</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>    {</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">m_ChatChannel</a>;</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>    }</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span> </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">  257</a></span>    <a class="code hl_class" href="../../de/da8/a04254.html">Chat</a> <a class="code hl_function" href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">GetChat</a>()</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>    {</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/d94/a00716.html#ae38cfc715c5007d38ba931e2ed1233f9">m_Chat</a>;</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>    }</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>    </div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#acbcf0c64743116229dae1da155069a82">  262</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#acbcf0c64743116229dae1da155069a82">PlayerControlDisable</a>(<span class="keywordtype">int</span> mode)</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>    {</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>        <span class="keywordflow">switch</span> (mode)</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        {</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>            <span class="keywordflow">case</span> <a class="code hl_variable" href="../../da/d28/a09115.html#acca8fa992257e3d4d1cb0f442fb66022">INPUT_EXCLUDE_CHAT_EXPANSION</a>:</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>            {</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>                GetUApi().ActivateExclude(<span class="stringliteral">&quot;chatexpansion&quot;</span>);</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>                GetUApi().UpdateControls();</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>            }</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>        }</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span> </div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        super.PlayerControlDisable(mode);</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>    }</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span> </div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno"><a class="line" href="../../d5/d3b/a03990.html#ad9319690e7754f3ecce784daca227221">  277</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d3b/a03990.html#ad9319690e7754f3ecce784daca227221">OnUpdate</a>(<span class="keywordtype">float</span> timeslice)</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>    {</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>        super.OnUpdate(timeslice);</div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span> </div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>        <span class="keywordflow">if</span> (!m_bLoaded)</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        {</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>        }</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span><span class="comment"></span> </div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span><span class="comment">        //! Checking for keyboard focus</span></div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span><span class="comment"></span>        <span class="keywordtype">bool</span> inputIsFocused = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span><span class="comment"></span> </div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span><span class="comment">        //! Reference to focused windget</span></div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span><span class="comment"></span>        Widget focusedWidget = GetFocus();</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span> </div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>        <span class="keywordflow">if</span> (focusedWidget)</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>        {</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>            <span class="keywordflow">if</span> (focusedWidget.ClassName().Contains(<span class="stringliteral">&quot;EditBoxWidget&quot;</span>))</div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>            {</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>                inputIsFocused = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>            }</div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (focusedWidget.ClassName().Contains(<span class="stringliteral">&quot;MultilineEditBoxWidget&quot;</span>))</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>            {</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>                inputIsFocused = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span>            }</div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>        }</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span> </div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        Man player = GetGame().GetPlayer(); <span class="comment">//! Reference to player</span></div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>        Input input = GetGame().GetInput(); <span class="comment">//! Reference to input</span></div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>        <a class="code hl_class" href="../../d1/d24/a04514.html">UIScriptedMenu</a> topMenu = m_UIManager.GetMenu(); <span class="comment">//! Reference to current opened scripted menu</span></div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>        <a class="code hl_class" href="../../d5/dfc/a05210.html">ExpansionScriptViewMenu</a> viewMenu = <a class="code hl_class" href="../../d5/dfc/a05210.html">ExpansionScriptViewMenu</a>.Cast(<a class="code hl_function" href="../../da/d11/a09022.html#a883da7b60e247b43fafd5f00b7829fa8">GetDayZExpansion</a>().GetExpansionUIManager().GetMenu()); <span class="comment">//! Reference to current opened script view menu</span></div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span> </div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span>        <span class="keywordflow">if</span> (player)</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>        {</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>            <span class="keywordflow">if</span> (m_LifeState == EPlayerStates.ALIVE &amp;&amp; !player.IsUnconscious())</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>            {</div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>                <span class="comment">//TODO: Make ExpansionInputs class and handle stuff there to keep this clean</span><span class="comment"></span></div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span><span class="comment">                //! Open main chat input and window</span></div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span><span class="comment"></span>                <span class="keywordflow">if</span> (input.LocalPress(<span class="stringliteral">&quot;UAChat&quot;</span>, <span class="keyword">false</span>) &amp;&amp; !inputIsFocused &amp;&amp; !topMenu &amp;&amp; !viewMenu)</div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>                {</div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>                    <a class="code hl_function" href="../../d5/d3b/a03990.html#a82d9062eb09f8de43262773a4ef64caa">ShowChat</a>();</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>                }</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span><span class="comment"></span> </div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span><span class="comment">                //! Hide chat toggle</span></div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span><span class="comment"></span>                <span class="keywordflow">if</span> (input.LocalPress(<span class="stringliteral">&quot;UAExpansionHideChatToggle&quot;</span>, <span class="keyword">false</span>) &amp;&amp; !inputIsFocused &amp;&amp; !topMenu &amp;&amp; !viewMenu)</div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>                {</div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>                    <a class="code hl_variable" href="../../d2/d94/a00716.html#ae38cfc715c5007d38ba931e2ed1233f9">m_Chat</a>.<a class="code hl_function" href="../../de/da8/a04254.html#aba11dae2be22c92eddee0b3189e236df">HideChatToggle</a>();</div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span> </div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>                    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d2/d94/a00716.html#ae38cfc715c5007d38ba931e2ed1233f9">m_Chat</a>.<a class="code hl_function" href="../../de/da8/a04254.html#a153ade0131ac723d28931701acb61dba">GetChatToggleState</a>())</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span>                    {</div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span>                        <a class="code hl_function" href="../../df/df7/a00731.html#a035f8a89b4bc04b99c33feb27da703fd">ExpansionNotification</a>(<span class="stringliteral">&quot;STR_EXPANSION_CHATTOGGLE_TITLE&quot;</span>, <span class="stringliteral">&quot;STR_EXPANSION_CHATTOGGLE_ON&quot;</span>, <a class="code hl_variable" href="../../da/d28/a09115.html#ab286d7d3a949f77fb83e5cbde3180942">EXPANSION_NOTIFICATION_ICON_T_Walkie_Talkie</a>, <a class="code hl_variable" href="../../da/d28/a09115.html#ad39fbc78a3cd87c7a01d35d926627060">COLOR_EXPANSION_NOTIFICATION_SUCCSESS</a>, 5).<a class="code hl_function" href="../../de/da2/a04294.html#a1395a0c78410f612fc3ca2c040ef1580">Info</a>(player.GetIdentity());</div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>                    }</div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span>                    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span>                    {</div>
<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span>                        <a class="code hl_function" href="../../df/df7/a00731.html#a035f8a89b4bc04b99c33feb27da703fd">ExpansionNotification</a>(<span class="stringliteral">&quot;STR_EXPANSION_CHATTOGGLE_TITLE&quot;</span>, <span class="stringliteral">&quot;STR_EXPANSION_CHATTOGGLE_OFF&quot;</span>, <a class="code hl_variable" href="../../da/d28/a09115.html#ab286d7d3a949f77fb83e5cbde3180942">EXPANSION_NOTIFICATION_ICON_T_Walkie_Talkie</a>, <a class="code hl_variable" href="../../da/d28/a09115.html#ad39fbc78a3cd87c7a01d35d926627060">COLOR_EXPANSION_NOTIFICATION_SUCCSESS</a>, 5).<a class="code hl_function" href="../../de/da2/a04294.html#a1395a0c78410f612fc3ca2c040ef1580">Info</a>(player.GetIdentity());</div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span>                    }</div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>                }</div>
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span><span class="comment"></span> </div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span><span class="comment">                //! Switch chat channel</span></div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span><span class="comment"></span>                <span class="keywordflow">if</span> (input.LocalPress(<span class="stringliteral">&quot;UAExpansionChatSwitchChannel&quot;</span>, <span class="keyword">false</span>) &amp;&amp; !inputIsFocused &amp;&amp; !topMenu &amp;&amp; !viewMenu)</div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span>                {</div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span>                    <a class="code hl_function" href="../../d5/d3b/a03990.html#a33850cfa9b721d7b55df4b85186d6b2e">SwitchChannel</a>();</div>
<div class="line"><a id="l00339" name="l00339"></a><span class="lineno">  339</span>                }</div>
<div class="line"><a id="l00340" name="l00340"></a><span class="lineno">  340</span>            }</div>
<div class="line"><a id="l00341" name="l00341"></a><span class="lineno">  341</span>        }</div>
<div class="line"><a id="l00342" name="l00342"></a><span class="lineno">  342</span>    }</div>
<div class="line"><a id="l00343" name="l00343"></a><span class="lineno">  343</span>};</div>
<div class="ttc" id="aa00704_html_a9ac85a6fe03a5ee2a389557e2c38fbd4"><div class="ttname"><a href="../../d4/d6a/a00704.html#a9ac85a6fe03a5ee2a389557e2c38fbd4">EnableTransportChat</a></div><div class="ttdeci">bool EnableTransportChat</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d6a/a00704_source.html#l00022">expansionchatsettings.c:22</a></div></div>
<div class="ttc" id="aa00704_html_aacf768f5738a580c7aa1604dcca74b9f"><div class="ttname"><a href="../../d4/d6a/a00704.html#aacf768f5738a580c7aa1604dcca74b9f">EnableGlobalChat</a></div><div class="ttdeci">bool EnableGlobalChat</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d6a/a00704_source.html#l00018">expansionchatsettings.c:18</a></div></div>
<div class="ttc" id="aa00716_html_ae38cfc715c5007d38ba931e2ed1233f9"><div class="ttname"><a href="../../d2/d94/a00716.html#ae38cfc715c5007d38ba931e2ed1233f9">m_Chat</a></div><div class="ttdeci">private ref Chat m_Chat</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/d94/a00716_source.html#l00023">expansionchatline.c:23</a></div></div>
<div class="ttc" id="aa00731_html_a035f8a89b4bc04b99c33feb27da703fd"><div class="ttname"><a href="../../df/df7/a00731.html#a035f8a89b4bc04b99c33feb27da703fd">ExpansionNotification</a></div><div class="ttdeci">class ExpansionNotificationTemplate&lt; Class T &gt; ExpansionNotification(StringLocaliser title, StringLocaliser text, string icon=&quot;&quot;, int color=0, float time=7, ExpansionNotificationType type=ExpansionNotificationType.TOAST)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/df7/a00731_source.html#l00066">expansionnotificationsystem.c:132</a></div></div>
<div class="ttc" id="aa00752_html_ac819a3ce2982b743e915becd7db4fb9d"><div class="ttname"><a href="../../dd/d5c/a00752.html#ac819a3ce2982b743e915becd7db4fb9d">GetExpansionClientSettings</a></div><div class="ttdeci">static ExpansionClientSettings GetExpansionClientSettings()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d5c/a00752_source.html#l01018">expansionclientsettings.c:1018</a></div></div>
<div class="ttc" id="aa00770_html_a94995a0febe96411aa47647d9f9e8ea4"><div class="ttname"><a href="../../d0/d7e/a00770.html#a94995a0febe96411aa47647d9f9e8ea4">ExpansionClientUIChatChannel</a></div><div class="ttdeci">ExpansionClientUIChatChannel</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d7e/a00770_source.html#l00013">expansionclientuichatchannel.c:14</a></div></div>
<div class="ttc" id="aa01010_html_a6a9dab57310f04a6f70fe20ef2e4eed3"><div class="ttname"><a href="../../d0/d2b/a01010.html#a6a9dab57310f04a6f70fe20ef2e4eed3">GetPermissionsManager</a></div><div class="ttdeci">ref ExpansionPermissionsManager GetPermissionsManager()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d2b/a01010_source.html#l00080">permissionsmanager.c:80</a></div></div>
<div class="ttc" id="aa03482_html"><div class="ttname"><a href="../../d1/d07/a03482.html">ExpansionSettings</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d71/a08728_source.html#l00013">expansionsettings.c:14</a></div></div>
<div class="ttc" id="aa03482_html_a269a0005757f7ab791bcaac0e46e46e2"><div class="ttname"><a href="../../d1/d07/a03482.html#a269a0005757f7ab791bcaac0e46e46e2">ExpansionSettings::SI_Chat</a></div><div class="ttdeci">static ref ScriptInvoker SI_Chat</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d44/a08734_source.html#l00015">expansionsettings.c:15</a></div></div>
<div class="ttc" id="aa03966_html"><div class="ttname"><a href="../../df/de5/a03966.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d29/a08947_source.html#l00013">playerbase.c:14</a></div></div>
<div class="ttc" id="aa03990_html"><div class="ttname"><a href="../../d5/d3b/a03990.html">MissionGameplay</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/dd8/a09064_source.html#l00016">missiongameplay.c:17</a></div></div>
<div class="ttc" id="aa03990_html_a04c04571e97be01a5aaf3a95293023bd"><div class="ttname"><a href="../../d5/d3b/a03990.html#a04c04571e97be01a5aaf3a95293023bd">MissionGameplay::SwitchChatChannelToGlobal</a></div><div class="ttdeci">void SwitchChatChannelToGlobal()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00125">missiongameplay.c:125</a></div></div>
<div class="ttc" id="aa03990_html_a0e4dc46b5bf478f9eecc3204b26a39dd"><div class="ttname"><a href="../../d5/d3b/a03990.html#a0e4dc46b5bf478f9eecc3204b26a39dd">MissionGameplay::m_ChatChannelName</a></div><div class="ttdeci">TextWidget m_ChatChannelName</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00021">missiongameplay.c:21</a></div></div>
<div class="ttc" id="aa03990_html_a1b46009109a2e05a507ed2009c245f3d"><div class="ttname"><a href="../../d5/d3b/a03990.html#a1b46009109a2e05a507ed2009c245f3d">MissionGameplay::SwitchChatChannelToTeam</a></div><div class="ttdeci">void SwitchChatChannelToTeam()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00140">missiongameplay.c:140</a></div></div>
<div class="ttc" id="aa03990_html_a20429d1d08dfd5dafa24401e408320ac"><div class="ttname"><a href="../../d5/d3b/a03990.html#a20429d1d08dfd5dafa24401e408320ac">MissionGameplay::SwitchChatChannelToTransport</a></div><div class="ttdeci">void SwitchChatChannelToTransport()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00161">missiongameplay.c:161</a></div></div>
<div class="ttc" id="aa03990_html_a33850cfa9b721d7b55df4b85186d6b2e"><div class="ttname"><a href="../../d5/d3b/a03990.html#a33850cfa9b721d7b55df4b85186d6b2e">MissionGameplay::SwitchChannel</a></div><div class="ttdeci">void SwitchChannel()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00207">missiongameplay.c:207</a></div></div>
<div class="ttc" id="aa03990_html_a4278bc91c411ab7ced753d59781ab9b5"><div class="ttname"><a href="../../d5/d3b/a03990.html#a4278bc91c411ab7ced753d59781ab9b5">MissionGameplay::GetChat</a></div><div class="ttdeci">Chat GetChat()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00257">missiongameplay.c:257</a></div></div>
<div class="ttc" id="aa03990_html_a5957a5e85046a480f944aa1c63504774"><div class="ttname"><a href="../../d5/d3b/a03990.html#a5957a5e85046a480f944aa1c63504774">MissionGameplay::MissionGameplay</a></div><div class="ttdeci">void MissionGameplay()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00025">missiongameplay.c:25</a></div></div>
<div class="ttc" id="aa03990_html_a5ee2435fb160330ada4b7d42a035ec80"><div class="ttname"><a href="../../d5/d3b/a03990.html#a5ee2435fb160330ada4b7d42a035ec80">MissionGameplay::m_ChatChannel</a></div><div class="ttdeci">ExpansionChatChannels m_ChatChannel</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00018">missiongameplay.c:18</a></div></div>
<div class="ttc" id="aa03990_html_a624b850617bf1855ccc4aa43410760a2"><div class="ttname"><a href="../../d5/d3b/a03990.html#a624b850617bf1855ccc4aa43410760a2">MissionGameplay::OnInit</a></div><div class="ttdeci">override void OnInit()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00037">missiongameplay.c:37</a></div></div>
<div class="ttc" id="aa03990_html_a82d9062eb09f8de43262773a4ef64caa"><div class="ttname"><a href="../../d5/d3b/a03990.html#a82d9062eb09f8de43262773a4ef64caa">MissionGameplay::ShowChat</a></div><div class="ttdeci">override void ShowChat()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00072">missiongameplay.c:72</a></div></div>
<div class="ttc" id="aa03990_html_a8cd37e08feb9c0cb32d542a34f8da2e6"><div class="ttname"><a href="../../d5/d3b/a03990.html#a8cd37e08feb9c0cb32d542a34f8da2e6">MissionGameplay::HideChat</a></div><div class="ttdeci">override void HideChat()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00113">missiongameplay.c:113</a></div></div>
<div class="ttc" id="aa03990_html_a970414f2d57648e4b93e7ac11f2cdca5"><div class="ttname"><a href="../../d5/d3b/a03990.html#a970414f2d57648e4b93e7ac11f2cdca5">MissionGameplay::m_ChatPanel</a></div><div class="ttdeci">Widget m_ChatPanel</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00019">missiongameplay.c:19</a></div></div>
<div class="ttc" id="aa03990_html_a978c2144ffb498ae0cd11c839b380583"><div class="ttname"><a href="../../d5/d3b/a03990.html#a978c2144ffb498ae0cd11c839b380583">MissionGameplay::SwitchChatChannelToAdmin</a></div><div class="ttdeci">void SwitchChatChannelToAdmin()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00184">missiongameplay.c:184</a></div></div>
<div class="ttc" id="aa03990_html_a98610ae06d9dc5a684ad7dd7bf7f0e2a"><div class="ttname"><a href="../../d5/d3b/a03990.html#a98610ae06d9dc5a684ad7dd7bf7f0e2a">MissionGameplay::InitExpansionChat</a></div><div class="ttdeci">void InitExpansionChat()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00044">missiongameplay.c:44</a></div></div>
<div class="ttc" id="aa03990_html_a9b5a2ee56dfa244ecc61ecd37406f91a"><div class="ttname"><a href="../../d5/d3b/a03990.html#a9b5a2ee56dfa244ecc61ecd37406f91a">MissionGameplay::GetChatChannel</a></div><div class="ttdeci">int GetChatChannel()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00252">missiongameplay.c:252</a></div></div>
<div class="ttc" id="aa03990_html_aa83059a78251c538dbc57b8d85cece01"><div class="ttname"><a href="../../d5/d3b/a03990.html#aa83059a78251c538dbc57b8d85cece01">MissionGameplay::Expansion_OnChatSettingsReceived</a></div><div class="ttdeci">void Expansion_OnChatSettingsReceived()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00059">missiongameplay.c:59</a></div></div>
<div class="ttc" id="aa03990_html_acbcf0c64743116229dae1da155069a82"><div class="ttname"><a href="../../d5/d3b/a03990.html#acbcf0c64743116229dae1da155069a82">MissionGameplay::PlayerControlDisable</a></div><div class="ttdeci">override void PlayerControlDisable(int mode)</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00262">missiongameplay.c:262</a></div></div>
<div class="ttc" id="aa03990_html_acf8a8220e80d16442e972c06f4004635"><div class="ttname"><a href="../../d5/d3b/a03990.html#acf8a8220e80d16442e972c06f4004635">MissionGameplay::~MissionGameplay</a></div><div class="ttdeci">void ~MissionGameplay()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00032">missiongameplay.c:32</a></div></div>
<div class="ttc" id="aa03990_html_ad3c5abcb28e385d4bad5a052a0c6ddc1"><div class="ttname"><a href="../../d5/d3b/a03990.html#ad3c5abcb28e385d4bad5a052a0c6ddc1">MissionGameplay::SwitchChatChannelToDirect</a></div><div class="ttdeci">void SwitchChatChannelToDirect()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00199">missiongameplay.c:199</a></div></div>
<div class="ttc" id="aa03990_html_ad9319690e7754f3ecce784daca227221"><div class="ttname"><a href="../../d5/d3b/a03990.html#ad9319690e7754f3ecce784daca227221">MissionGameplay::OnUpdate</a></div><div class="ttdeci">override void OnUpdate(float timeslice)</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00277">missiongameplay.c:277</a></div></div>
<div class="ttc" id="aa03990_html_aee84cfd70f2fdf1e6b161cde0b0c8877"><div class="ttname"><a href="../../d5/d3b/a03990.html#aee84cfd70f2fdf1e6b161cde0b0c8877">MissionGameplay::UpdateChannelColor</a></div><div class="ttdeci">void UpdateChannelColor()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00241">missiongameplay.c:241</a></div></div>
<div class="ttc" id="aa03990_html_afe0a9f610fca7dc48005c29283028b98"><div class="ttname"><a href="../../d5/d3b/a03990.html#afe0a9f610fca7dc48005c29283028b98">MissionGameplay::m_ExChatChannelHideTimer</a></div><div class="ttdeci">ref Timer m_ExChatChannelHideTimer</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00023">missiongameplay.c:23</a></div></div>
<div class="ttc" id="aa03990_html_affaf282e28d29b6bc311bece5d26c25b"><div class="ttname"><a href="../../d5/d3b/a03990.html#affaf282e28d29b6bc311bece5d26c25b">MissionGameplay::m_ChatChannelRootWidget</a></div><div class="ttdeci">Widget m_ChatChannelRootWidget</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d96/a09070_source.html#l00020">missiongameplay.c:20</a></div></div>
<div class="ttc" id="aa04254_html"><div class="ttname"><a href="../../de/da8/a04254.html">Chat</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d4/deb/a00710_source.html#l00013">chat.c:14</a></div></div>
<div class="ttc" id="aa04254_html_a153ade0131ac723d28931701acb61dba"><div class="ttname"><a href="../../de/da8/a04254.html#a153ade0131ac723d28931701acb61dba">Chat::GetChatToggleState</a></div><div class="ttdeci">bool GetChatToggleState()</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/deb/a00710_source.html#l00062">chat.c:62</a></div></div>
<div class="ttc" id="aa04254_html_aba11dae2be22c92eddee0b3189e236df"><div class="ttname"><a href="../../de/da8/a04254.html#aba11dae2be22c92eddee0b3189e236df">Chat::HideChatToggle</a></div><div class="ttdeci">void HideChatToggle()</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/deb/a00710_source.html#l00056">chat.c:56</a></div></div>
<div class="ttc" id="aa04294_html_a1395a0c78410f612fc3ca2c040ef1580"><div class="ttname"><a href="../../de/da2/a04294.html#a1395a0c78410f612fc3ca2c040ef1580">ExpansionNotificationTemplate&lt; Class T &gt;::Info</a></div><div class="ttdeci">void Info(PlayerIdentity identity=NULL)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/df7/a00731_source.html#l00115">expansionnotificationsystem.c:115</a></div></div>
<div class="ttc" id="aa04318_html_a177040c829eb22a3df76b96af4aa64f9"><div class="ttname"><a href="../../d3/d8c/a04318.html#a177040c829eb22a3df76b96af4aa64f9">ExpansionClientSettings::DefaultChatChannel</a></div><div class="ttdeci">ExpansionClientUIChatChannel DefaultChatChannel</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d5c/a00752_source.html#l00087">expansionclientsettings.c:87</a></div></div>
<div class="ttc" id="aa04370_html"><div class="ttname"><a href="../../d7/dc9/a04370.html">EXTrace</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d1c/a00824_source.html#l00029">expansiontracing.c:30</a></div></div>
<div class="ttc" id="aa04370_html_ab7af4b282c08a043d2f9626231c59953"><div class="ttname"><a href="../../d7/dc9/a04370.html#ab7af4b282c08a043d2f9626231c59953">EXTrace::Start</a></div><div class="ttdeci">static EXTrace Start(bool yes=true, Class instance=null, string param0=&quot;&quot;, string param1=&quot;&quot;, string param2=&quot;&quot;, string param3=&quot;&quot;, string param4=&quot;&quot;, string param5=&quot;&quot;, string param6=&quot;&quot;, string param7=&quot;&quot;, string param8=&quot;&quot;, string param9=&quot;&quot;)</div><div class="ttdoc">Includes 1st line of stack.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d1c/a00824_source.html#l00325">expansiontracing.c:325</a></div></div>
<div class="ttc" id="aa04514_html"><div class="ttname"><a href="../../d1/d24/a04514.html">UIScriptedMenu</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d54/a00938_source.html#l00013">expansionuiscriptedmenu.c:14</a></div></div>
<div class="ttc" id="aa05210_html"><div class="ttname"><a href="../../d5/dfc/a05210.html">ExpansionScriptViewMenu</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d85/a01352_source.html#l00013">expansionscriptviewmenu.c:14</a></div></div>
<div class="ttc" id="aa05322_html"><div class="ttname"><a href="../../da/d4d/a05322.html">ExpansionPartyModule</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d1c/a01397_source.html#l00014">expansionpartymodule.c:15</a></div></div>
<div class="ttc" id="aa05322_html_a95efaaf7798d3ceb3a74fd2aebf3235d"><div class="ttname"><a href="../../da/d4d/a05322.html#a95efaaf7798d3ceb3a74fd2aebf3235d">ExpansionPartyModule::HasParty</a></div><div class="ttdeci">bool HasParty()</div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d1c/a01397_source.html#l01316">expansionpartymodule.c:1316</a></div></div>
<div class="ttc" id="aa08737_html_a0a20d14d2f55a927a3b0eab0623f5cf9"><div class="ttname"><a href="../../d7/d1c/a08737.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a></div><div class="ttdeci">static ExpansionSettings GetExpansionSettings()</div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d1c/a08737_source.html#l00262">expansionsettings.c:262</a></div></div>
<div class="ttc" id="aa09022_html_a883da7b60e247b43fafd5f00b7829fa8"><div class="ttname"><a href="../../da/d11/a09022.html#a883da7b60e247b43fafd5f00b7829fa8">GetDayZExpansion</a></div><div class="ttdeci">static DayZExpansion GetDayZExpansion()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d11/a09022_source.html#l00104">dayzexpansion.c:104</a></div></div>
<div class="ttc" id="aa09115_html_a56eb990d389c3c18dab75890233ffc93"><div class="ttname"><a href="../../da/d28/a09115.html#a56eb990d389c3c18dab75890233ffc93">ExpansionChatChannels</a></div><div class="ttdeci">ExpansionChatChannels</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d28/a09115_source.html#l00017">expansionconstants.c:18</a></div></div>
<div class="ttc" id="aa09115_html_ab286d7d3a949f77fb83e5cbde3180942"><div class="ttname"><a href="../../da/d28/a09115.html#ab286d7d3a949f77fb83e5cbde3180942">EXPANSION_NOTIFICATION_ICON_T_Walkie_Talkie</a></div><div class="ttdeci">static const string EXPANSION_NOTIFICATION_ICON_T_Walkie_Talkie</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d28/a09115_source.html#l00201">expansionconstants.c:201</a></div></div>
<div class="ttc" id="aa09115_html_acca8fa992257e3d4d1cb0f442fb66022"><div class="ttname"><a href="../../da/d28/a09115.html#acca8fa992257e3d4d1cb0f442fb66022">INPUT_EXCLUDE_CHAT_EXPANSION</a></div><div class="ttdeci">const int INPUT_EXCLUDE_CHAT_EXPANSION</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d28/a09115_source.html#l00044">expansionconstants.c:44</a></div></div>
<div class="ttc" id="aa09115_html_ad39fbc78a3cd87c7a01d35d926627060"><div class="ttname"><a href="../../da/d28/a09115.html#ad39fbc78a3cd87c7a01d35d926627060">COLOR_EXPANSION_NOTIFICATION_SUCCSESS</a></div><div class="ttdeci">static const int COLOR_EXPANSION_NOTIFICATION_SUCCSESS</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d28/a09115_source.html#l00067">expansionconstants.c:67</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_b52f1e3f449ac30f095dc773fc3aed12.html">Chat</a></li><li class="navelem"><a class="el" href="../../dir_ab508822baf8132ac49b84b54fcdf970.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_7683f2b88c7d828af0667d1b79d2ea4a.html">5_mission</a></li><li class="navelem"><a class="el" href="../../dir_f939718bd8f4981caf95a236da11f39f.html">dayzexpansion_chat</a></li><li class="navelem"><a class="el" href="../../de/d96/a09070.html">missiongameplay.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
